#include "giis.h"
/*
* /giis/gtk_tab1.c-Functions needed for GUI.
*
* Copyright (C) 2009. G.Lakshmipathi.<lakshmipathi.g@gmail.com>
*
*/

/*
First run gtk_tab1.glade through gtk-builder-convert with this command:
  gtk-builder-convert gtk_tab1.glade gtk_tab1.xml
  
Then save this file as gtk_tab1.c and compile it using this command
(those are backticks, not single quotes):
  gcc -Wall -g -o gtk_tab1 gtk_tab1.c `pkg-config --cflags --libs gtk+-2.0` -export-dynamic
  
Then execute it using:
  ./gtk_tab1
*/


char *gargv[100];

extern GtkTextBuffer *buffer,*buffer1,*buffer2,*buffer3; //to store data.
extern char gtk_del_file_names[500];
extern int gtk_get_all_user_files;

void on_main_win_destroy (GtkObject *object, gpointer user_data);
void on_btn_viewfiles_clicked(GtkButton *button);//list of deleted files
void on_btn_get_all_user_clicked(GtkButton *button); //get all users file
int no_of_arg;

void on_chk_btn_rere_toggled(GtkButton *button){
if(rere)
rere=0;
else
rere=1;


}

void on_spin_update_value_changed(){
gint time;
time=(gint)gtk_spin_button_get_value(from_gui->spin_update);

char ia[2];
if(time>9){
ia[0]=(time/10)+'0';
time=time%10;
ia[1]=(time%10)+'0';
ia[2]='\0';
}
else{
ia[0]=time+'0';
ia[1]='\0';
}

time_change(ia);
}
void on_spin_update1_value_changed(){
gint time;


time=(gint)gtk_spin_button_get_value(from_gui->spin_update1);

char ia[2];
if(time>9){
ia[0]=(time/10)+'0';
time=time%10;
ia[1]=(time%10)+'0';
ia[2]='\0';
}
else{
ia[0]=time+'0';
ia[1]='\0';
}

max_dir_depth(ia);

}

//update max. directory depth
void max_dir_depth(char depth[2]){
char b[]="$LEVEL_VALUE = ";
char a[4096],d[4096];
char c[100]="$LEVEL_VALUE = ";
int i,j,k,tfp,l,m=0;


i=0;
memset(d,'\0',4096);
strcat(strcat(c,depth),"$");


tfp=open(GIIS_CONF_FILE,0);
if(tfp ==  -1)
{
//printf("\n Unable to load config file");
exit(0);
}
//read the file
i=read(tfp,a,4096);
close(tfp);

i=0;l=0;
while(a[i]!='\0'){
j=0;
k=i;

	while((b[j]==a[k]) && (b[j]!='\0')){
		j++;
		k++;
		}
	
	if(b[j]=='\0'){
	    
		i=k+3;
	m=0;
		while(c[m]!='\0'){
			d[l]=c[m];
			m++;
			l++;
	}
	}
	else{
	d[l]=a[i];
	i++;
	l++;
	}
	
}

//Search Ends
//write it
tfp=open(GIIS_CONF_FILE,1);
if(tfp ==  -1)
{
printf("\n Unable to load config file");
exit(0);
}
//read the file
i=write(tfp,d,4096);
close(tfp);
}

//end max. dir depth
//update time in giis.conf file
void time_change(char time[2]){
char b[]="$TIME = ";
char a[4096],d[4096];
char c[100]="$TIME = ";
int i,j,k,tfp,l,m=0;


i=0;
memset(d,'\0',4096);
strcat(strcat(c,time),"$");


tfp=open(GIIS_CONF_FILE,0);
if(tfp ==  -1)
{
printf("\n Unable to load config file");
exit(0);
}
//read the file
i=read(tfp,a,4096);
close(tfp);

i=0;l=0;
while(a[i]!='\0'){
j=0;
k=i;

	while((b[j]==a[k]) && (b[j]!='\0')){
		j++;
		k++;
		}
	
	if(b[j]=='\0'){
	    
		i=k+3;
	m=0;
		while(c[m]!='\0'){
			d[l]=c[m];
			m++;
			l++;
	}
	}
	else{
	d[l]=a[i];
	i++;
	l++;
	}
	
}
//Search Ends
//write it
tfp=open(GIIS_CONF_FILE,1);
if(tfp ==  -1)
{
printf("\n Unable to load config file");
exit(0);
}
//read the file
i=write(tfp,d,4096);
close(tfp);
}
//end - update time in .conf file
//add directories  to .conf file
gtk_add_directory(char dir_name[100]){
char b[]="$DIR = home$";
char a[4096],d[4096];
char c[100]="$DIR = home$\n";
int i,j,k,tfp,l,m=0;
int arg;

memset(d,'\0',4096);
i=0;arg=1;
strcat(strcat(strcat (c,"$DIR = "),dir_name),"$");
printf("%s",c);
tfp=open(GIIS_CONF_FILE,0);
if(tfp ==  -1)
{
printf("\n Unable to load config file");
dialog_success_message("Unable to load config file..exiting");

exit(0);
}
//read the file
i=read(tfp,a,4096);
close(tfp);

i=0;l=0;
while(a[i]!='\0'){
j=0;
k=i;

	while((b[j]==a[k]) && (b[j]!='\0')){
		j++;
		k++;
		}
	
	if(b[j]=='\0'){
		i=k;
	m=0;
		while(c[m]!='\0'){
			d[l]=c[m];
			m++;
			l++;
	}
	}
	else{
	d[l]=a[i];
	i++;
	l++;
	}
	
}
//Search Ends

//write it
tfp=open(GIIS_CONF_FILE,1);
if(tfp ==  -1)
{
printf("\n Unable to load config file");
dialog_success_message("Unable to load config file..exiting");
exit(0);
}
//read the file
i=write(tfp,d,4096);
close(tfp);


}

// ends
void  on_btn_remove_dir_clicked(){
gchar *txt_entry_dir1 = gtk_entry_get_text(from_gui->txt_entry_dir);


if((strcmp(txt_entry_dir1,"root")==0) || (strcmp(txt_entry_dir1,"home")==0))
{
printf("\n can't remove directories");
}

     //delete 3rd line
	GtkTextIter iter,start,end;
	gboolean found;
	gtk_text_buffer_get_start_iter(buffer1,&iter);
	found=gtk_text_iter_forward_search(&iter,txt_entry_dir1,0,&start,&end,NULL);
	if(found)
	{
	gtk_text_buffer_select_range(buffer1,&start,&end);
	gtk_text_buffer_delete(buffer1,&start,&end);
	}
	
return;
}
void  on_btn_add_dir_clicked(){

gchar *txt_entry_dir1 = gtk_entry_get_text(from_gui->txt_entry_dir);
gtk_add_directory(txt_entry_dir1);

gtk_text_buffer_insert_at_cursor(buffer1, txt_entry_dir1, -1);
gtk_text_buffer_insert_at_cursor(buffer1, "\n", -1);

}

int gtk_list_del_files () {
	
        
	 
	//no_of_arg=argc;
//A convenience macro to allocate a block of memory from the slice allocator
	from_gui = g_slice_new (TAB1); 
	//gtk_init (&gtk_argc, &gtk_argv);
 
	builder = gtk_builder_new ();
	gtk_builder_add_from_file (builder, "gui/giis46.xml", NULL);

	/* Get values and assign to struct "from_gui" */
	from_gui->main_win= GTK_WIDGET (gtk_builder_get_object (builder, "main_win"));
	from_gui->notebook1=GTK_WIDGET (gtk_builder_get_object (builder, "notebook1"));

	from_gui->viewfiles=GTK_WIDGET (gtk_builder_get_object (builder, "viewfiles"));
	from_gui->undelete=GTK_WIDGET (gtk_builder_get_object (builder, "undelete"));
	from_gui->settings=GTK_WIDGET (gtk_builder_get_object (builder, "settings"));
	from_gui->about=GTK_WIDGET (gtk_builder_get_object (builder, "about"));


        from_gui->btn_viewfiles = 	GTK_WIDGET (gtk_builder_get_object (builder, "btn_viewfiles"));
	from_gui->textview_viewfiles = GTK_WIDGET (gtk_builder_get_object (builder, "textview_viewfiles"));
	from_gui->textview_recovered = GTK_WIDGET (gtk_builder_get_object (builder, "textview_recovered"));
	from_gui->textview_corrupt = GTK_WIDGET (gtk_builder_get_object (builder, "textview_corrupt"));
	from_gui->btn_get_all_user = GTK_WIDGET (gtk_builder_get_object (builder, "btn_get_all_user"));

	from_gui->txt_entry_username = GTK_WIDGET (gtk_builder_get_object (builder, "txt_entry_username"));
	from_gui->txt_entry_filetype = GTK_WIDGET (gtk_builder_get_object (builder, "txt_entry_filetype"));


	 /* Deleted date values */
	//radio buttons
	from_gui->radio_btn_del_on = GTK_WIDGET (gtk_builder_get_object (builder, "radio_btn_del_on"));
	from_gui->radio_btn_del_after = GTK_WIDGET (gtk_builder_get_object (builder, "radio_btn_del_after"));
	from_gui->radio_btn_del_before = GTK_WIDGET (gtk_builder_get_object (builder, "radio_btn_del_before"));
	from_gui->radio_btn_del_between	 = GTK_WIDGET (gtk_builder_get_object (builder, "radio_btn_del_between"));
	//day- month -year
	from_gui->txt_entry_day = GTK_WIDGET (gtk_builder_get_object (builder, "txt_entry_day"));
	from_gui->txt_entry_year = GTK_WIDGET (gtk_builder_get_object (builder, "txt_entry_year"));
	from_gui->txt_entry_month = GTK_WIDGET (gtk_builder_get_object (builder, "txt_entry_month"));   

	//To date -day- month -year
	from_gui->txt_entry_day1 = GTK_WIDGET (gtk_builder_get_object (builder, "txt_entry_day1"));
	from_gui->txt_entry_year1 = GTK_WIDGET (gtk_builder_get_object (builder, "txt_entry_year1"));
	from_gui->txt_entry_month1 = GTK_WIDGET (gtk_builder_get_object (builder, "txt_entry_month1"));   

	//giis dump
	from_gui->txt_entry_filename = GTK_WIDGET (gtk_builder_get_object (builder, "txt_entry_filename"));   
	 //auto - update time
	from_gui->spin_update = GTK_WIDGET (gtk_builder_get_object (builder, "spin_update"));   		
	from_gui->spin_update1 = GTK_WIDGET (gtk_builder_get_object (builder, "spin_update1"));
	//Add directory
	from_gui->txt_entry_dir = GTK_WIDGET (gtk_builder_get_object (builder, "txt_entry_dir"));   		


	from_gui->txt_protected_dirs= GTK_WIDGET (gtk_builder_get_object (builder, "txt_protected_dirs"));   		

	/* Initialize buffer for textview */
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (from_gui->textview_viewfiles));
	buffer1 = gtk_text_view_get_buffer (GTK_TEXT_VIEW (from_gui->txt_protected_dirs));

	buffer2 = gtk_text_view_get_buffer (GTK_TEXT_VIEW (from_gui->textview_recovered));
	buffer3 = gtk_text_view_get_buffer (GTK_TEXT_VIEW (from_gui->textview_corrupt));

	from_gui->lbl_updating=GTK_WIDGET (gtk_builder_get_object (builder, "lbl_updating"));
	
  	 gtk_builder_connect_signals (builder, NULL);
 
   	 g_object_unref (G_OBJECT (builder));
	 //initialize giis.
	 init();
   	 gtk_widget_show (from_gui->main_win);                
  
   	 gtk_main ();
  exit(0);
}



void on_main_win_destroy (GtkObject *object, gpointer user_data){
	/*Makes the innermost invocation of the main loop return when it regains control. */
	gtk_main_quit();
}
void on_btn_uninstall_clicked(){
char *text_mesg="<big><big><span foreground=\"#038900\"><u>giis uninstalled from the  system.</u></span></big></big>";
remove_giis ();
gtk_label_set_markup(from_gui->lbl_updating, text_mesg);

}
void on_btn_fs_details_clicked(){

char *text_mesg="Fs details";
char fs_detail[500];
  
//strcat(strcat(fs_detail,"\n\t Root Device: "),device_name);
char tmp[200];
//sprintf(tmp,"%llu",fs.inodes_count);
//tmp="rel";
//strcat(strcat(fs_detail,"\n\t Magic Number: "),tmp);
//strcat(strcat(fs_detail,"\n\t Magic Number: "),isb.sb.s_magic);
//strcat(strcat(fs_detail,"\n\t Root Inode offset: "),fs.root_inode_offset);
//strcat(strcat(fs_detail,"\n\t Total Inodes:"),fs.inodes_count);
/*strcat(strcat(fs_detail,"\n\t Total Blocks: "),fs.blocks_count);
strcat(strcat(fs_detail,"\n\t Inodes per Group: "),fs.inodes_per_group);
strcat(strcat(fs_detail,"\n\t Blocks per Group: "),fs.blocks_per_group);
strcat(strcat(fs_detail,"\n\t Block size: "),fs.block_size);
strcat(strcat(fs_detail,"\n\t Inodes per Block: "),fs.inodes_per_block);
strcat(strcat(fs_detail,"\n\t Inode Table size: "),fs.inode_table_size);
strcat(strcat(fs_detail,"\n\t Groups count: "),fs.groups_count);
*/

text_mesg=fs_detail;
gtk_label_set_markup(from_gui->lbl_updating, text_mesg);

}
//giis -u
void on_btn_manual_update_clicked(){
gtk_label_set_markup(from_gui->lbl_updating, "<big><big><span foreground=\"#038900\"><u>Please wait this process may take some time to complete.</u></span></big></big>");
      install = 0;
      update_file = 1;
      update_dir = 1;
      search4dir ();          /* searches for directory in DIR_INFO_FILE */
char *text_mesg="<big><big><span foreground=\"#038900\"><u>giis manual update completed.</u></span></big></big>";
gtk_label_set_markup(from_gui->lbl_updating, text_mesg);


}
//giis -g
/* GTK get all user files*/

//Get all user files
void on_btn_get_all_user_clicked(GtkButton *button){
    int ans;
    ans=0;//scanf input
    use_uid = ans;
    install = 0;

    get_it ();                  /* Search for deleted file */
 dialog_success_message("For results check 'View files' tab - all/any recovered files available at /giis/got_it");

   
}
//Get a specific user files
void on_btn_get_a_user_clicked(GtkButton *button){
    int ans;
    ans=1;//scanf input
    use_uid = ans;
    install = 0;
    get_it ();                  /* Search for deleted file */
dialog_success_message("For results check 'View files' tab - all/any recovered files available at /giis/got_it");
}

//giis dump
void on_btn_force_giis_clicked(GtkButton *button){
int ans;
    ans=2;//scanf input
    use_uid = ans;
    install = 0;
    get_it ();                  /* Search for deleted file */
dialog_success_message("For results check 'View files' tab - all/any recovered files available at /giis/got_it");
}

//Get by file format
void on_btn_get_filetype_clicked(GtkButton *button){
int ans;
    ans=3;//scanf input
    use_uid = ans;
    install = 0;
    get_it ();                  /* Search for deleted file */
dialog_success_message("For results check 'View files' tab - all/any recovered files available at /giis/got_it");

}
//Deleted date
void on_btn_get_deleted_date_clicked(){
GtkButton *button;
 int ans;
    ans=0;//same as option 0. but has date mode value set between 0 to 3
//date mode-0 deleted on,1-afer,2-before,3-between
	
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(from_gui->radio_btn_del_on)))
	{date_mode=0;}
	else
	;//g_printf("Deleted on NOT ok");
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(from_gui->radio_btn_del_after)))
	{ date_mode=1;}
	else
	;//g_printf("Deleted not after ok");
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(from_gui->radio_btn_del_before)))
	{ date_mode=2;}
	else
	;//g_printf("Deleted not b4 ok");
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(from_gui->radio_btn_del_between)))
	{ date_mode=3;}
	else
	;//g_printf("Deleted not between ok");


//set day,month,year
    // date validation
	if(((day<=0 || day>31)||(month<=0 || month>12)||(year<1000))||((date_mode == 3)&&(day1<=0 || day1>31 || month1<=0 || month1>12|| year1<1000 )))
	{
	printf("\n Please Enter Valid Date.");
	}


	gchar *txt_day_input = gtk_entry_get_text(from_gui->txt_entry_day); //Retrieves the contents of the entry widge
	gchar *txt_month_input = gtk_entry_get_text(from_gui->txt_entry_month); //Retrieves the contents of the entry widge
	gchar *txt_year_input = gtk_entry_get_text(from_gui->txt_entry_year); //Retrieves the contents of the entry widge


	//Converts a string to a guint64 value.
	int g_day = g_ascii_strtoull(txt_day_input, NULL, 0);
	int g_month = g_ascii_strtoull(txt_month_input, NULL, 0);
	int g_year = g_ascii_strtoull(txt_year_input, NULL, 0);

	//assign to global values
	day=g_day;
	month=g_month;
	year=g_year;

	if(date_mode == 3){

	gchar *txt_day_input1 = gtk_entry_get_text(from_gui->txt_entry_day1); //Retrieves the contents of the entry widge
	gchar *txt_month_input1 = gtk_entry_get_text(from_gui->txt_entry_month1); //Retrieves the contents of the entry widge
	gchar *txt_year_input1 = gtk_entry_get_text(from_gui->txt_entry_year1); //Retrieves the contents of the entry widge


	//Converts a string to a guint64 value.
	int g_day1 = g_ascii_strtoull(txt_day_input1, NULL, 0);
	int g_month1 = g_ascii_strtoull(txt_month_input1, NULL, 0);
	int g_year1 = g_ascii_strtoull(txt_year_input1, NULL, 0);

	//assign to global values
	day1=g_day1;
	month1=g_month1;
	year1=g_year1;

	}
    use_uid = ans;


    install = 0;
    get_it ();                  /* Search for deleted file */
dialog_success_message("For results check 'View files' tab - all/any recovered files available at /giis/got_it");
}

//dialog box with  
void dialog_success_message(char *mesg){
GtkWidget *dialog, *label, *image, *hbox;
  GtkWindow *parent;
  /* Create a non-modal dialog with one OK button. */
  dialog = gtk_dialog_new_with_buttons ("gET iT i sAY - info", parent,
                                        GTK_DIALOG_DESTROY_WITH_PARENT,
                                        GTK_STOCK_OK, GTK_RESPONSE_OK,
                                        NULL);

  gtk_dialog_set_has_separator (GTK_DIALOG (dialog), FALSE);
  
  label = gtk_label_new (mesg);
  image = gtk_image_new_from_stock (GTK_STOCK_DIALOG_INFO, 
                                    GTK_ICON_SIZE_DIALOG);

  hbox = gtk_hbox_new (FALSE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (hbox), 10);
  gtk_box_pack_start_defaults (GTK_BOX (hbox), image);
  gtk_box_pack_start_defaults (GTK_BOX (hbox), label);

  gtk_box_pack_start_defaults (GTK_BOX (GTK_DIALOG (dialog)->vbox), hbox);
  gtk_widget_show_all (dialog);

  /* Call gtk_widget_destroy() when the dialog emits the response signal. */
  g_signal_connect (G_OBJECT (dialog), "response",
                    G_CALLBACK (gtk_widget_destroy), NULL);

    //files
    GDir *dir;
    const char *dirname;
    dir=g_dir_open("/giis/got_it",0,NULL);
    if(dir == NULL)
    return;
    dirname=g_dir_read_name(dir);
    while(dirname != NULL)
    {
    printf("\n %s",dirname);
    gtk_text_buffer_insert_at_cursor(buffer2, dirname, -1);
    gtk_text_buffer_insert_at_cursor(buffer2, "\n", -1);
    dirname=g_dir_read_name(dir);
    }

    //corrupted files
	
  dir=g_dir_open("/giis/unrecovered",0,NULL);
  if(dir == NULL)
  return;
  dirname=g_dir_read_name(dir);
  while(dirname != NULL)
  {
  //printf("\n %s",dirname);
  gtk_text_buffer_insert_at_cursor(buffer3, dirname, -1);
  gtk_text_buffer_insert_at_cursor(buffer3, "\n", -1);    
  dirname=g_dir_read_name(dir);
  }	

}


void on_notebook1_switch_page (){
GtkNotebook *nb; 
GtkNotebookPage *page;
guint page_num;
gpointer data;
if(gtk_notebook_get_current_page(from_gui->notebook1)==2){
//populate  spin button values
read_config_file("$TIME = ");
gtk_entry_set_text(from_gui->spin_update,auto_time);
read_config_file("$LEVEL_VALUE = ");
gtk_entry_set_text(from_gui->spin_update1,s_level_value);


if(gtk_text_buffer_get_line_count(buffer1)==1){
//populate text buffer area
read_config_file2();
auto int i=0;
for(i=0;i<(g_row-1);i++){
gtk_text_buffer_insert_at_cursor(buffer1,strcat(g_directory[i],"\n"), -1);
}
}
}
gtk_label_set_markup(from_gui->lbl_updating, " ");
}
